#ifndef _Bees_h_
#define _Bees_h_

#include "SceneElement.h"
#include "dcuTextureSet.h"

#define BEES_MAX_FLOWERS 32

class Bees : public SceneElement
	{
	public:
	 Bees(char *options,dcuTextureSet *texset=NULL,int loadtex=0);
	 virtual void GLInitialize(void);
	 virtual void Render(void);
	 virtual void Update(float dt);
	 virtual void InitSound(class bergenServer *server);
	 virtual void UpdateSound(float *userpos);
	 virtual void EndSound(void);
	private:
	 int numbees_,numflowers_;
	 float hive_[3],flower_[BEES_MAX_FLOWERS][3];
	 float xsize_,ysize_;
	 char *soundfile_;
	 char *hitsoundfile_;
	 int *mode_;
	 float *time_;
	 float *x_,*y_,*z_;
	 float *ry_;
	 float *phase_;
	 int *dest_;
	 struct _Bees_delta { float dx,dy,dz; } *delta_;
	 unsigned long color_;
	 GLuint gl_obj_;
	 class bergenSample *note_, *hitnote_;
	 float ampl_,pitch_;
	 int hithive_;
	 void InitValues(void);
	 void ParseOption(char *);
	 void HangOut(int,float);
	 void GoFlower(int,float);
	 void Pollenate(int,float);
	 void GoHive(int,float);
	 void Swarm(int,float);
	 void CheckUser(void);
	};

#endif
