#ifndef _Butterfly_h_
#define _Butterfly_h_

#include "SceneElement.h"
#include "dcuTextureSet.h"

class Butterfly : public SceneElement
	{
	public:
	 Butterfly(char *options,dcuTextureSet *texset=NULL,int loadtex=0);
	 virtual void GLInitialize(void);
	 virtual void Render(void);
	 virtual void Update(float dt);
	private:
	 float *ry_;
	 float dry_;
	 float *phase_;
	 float flapspeed_;
	 unsigned long color_;
	 float vy_;
	 float speed_;
	 int mode_;
	 float actiontime_;
	 float hand_[3];
	 void InitValues(void);
	 void ParseOption(char *);
	 void DrawButterfly(void);
	 void Wander(float);
	 void Seek(void);
	 void Rest(float);
	 void PickMode(float);
	 void Move(float);
	};

#endif
