#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "Flies.h"
#include "util.h"

Flies::Flies(char *options)
{
 char *token;
 center_[0] = center_[1] = center_[2] = 0;
 *radius_ = 1;
 num_flies_ = 1;
 cullable_ = 1;
 while (token = dcuNextToken(&options))
	ParseOption(token);
}

void Flies::ParseOption(char *optionstr)
{
 enum _option { OPT_POSITION, OPT_RADIUS, OPT_NUMBER } opttype;
 struct _dcukeyword opt_table[] = {
	{ "position", OPT_POSITION },
	{ "pos", OPT_POSITION },
	{ "radius", OPT_RADIUS },
	{ "size", OPT_RADIUS },
	{ "scale", OPT_RADIUS },
	{ "number", OPT_NUMBER },
	{ "num", OPT_NUMBER },
	{ "count", OPT_NUMBER },
	{ NULL, -1 }
	};
 char *eq,*value;
 eq = strchr(optionstr,'=');
 if (!eq) return;
 *eq = '\0';
 value = eq+1;
 opttype = (enum _option) dcuGetStringID(optionstr,opt_table);
 switch (opttype)
	{
	case OPT_POSITION:
		sscanf(value,"%f,%f,%f",&center_[0],&center_[1],&center_[2]);
		break;
	case OPT_RADIUS:
		sscanf(value,"%f",radius_);
		break;
	case OPT_NUMBER:
		sscanf(value,"%d",&num_flies_);
		break;
	default:
		fprintf(stderr,"CRAY Flies ERROR: Unknown option \"%s\"\n",
			optionstr);
	}
}

void Flies::GLInitialize(void)
{
}

void Flies::Render(void)
{
 float v[3];
 int i;
 glColor4f(0.0,0.0,0.0,0.5);
 glPointSize(2.0);
 glBegin(GL_POINTS);
 for (i=0; i<num_flies_; i++)
	{
	v[0] = center_[0] + (drand48()+drand48()-1)*(*radius_);
	v[1] = center_[1] + (drand48()+drand48()-1)*(*radius_);
	v[2] = center_[2] + (drand48()+drand48()-1)*(*radius_);
	glVertex3fv(v);
	}
 glEnd();
 glPointSize(1.0);
}

void Flies::Update(float)
{
}
