#ifndef _PictureObject_h_
#define _PictureObject_h_

#include "Picture.h"
#include "dcuTextureSet.h"

class PictureObject : public Picture
	{
	public:
	 PictureObject(char *options,dcuTextureSet *texset,int loadimage=0);
	 virtual void GLInitialize(void);
	 virtual void Render(void);
	 virtual void Update(float dt);
	private:
	 volatile float *transform_;	/* Matrix in shared memory */
	 volatile int *grabbed_;
	 float vx_,vy_,vz_;
	 float prevx_,prevy_,prevz_,prevt_;
	 int WandTouching(void);
	 void GetWandMatrix(float * m);
	 void MatrixMultiply(float * a,float * b,float * out);
	 void GetVelocity(float dt);
	 void Move(float dt);
	};

#endif
